library ieee;
use ieee.std_logic_1164.all;

entity multiplicador_1 is
    port (x,y,z,w: in std_logic; cout, product: out std_logic);
end multiplicador_1;

architecture flujo of multiplicador_1 is

        signal a, b, c, d: std_logic;

begin

        a <= x and y after 2 ns;
        b <= z and a after 2 ns;
        c <= z xor a after 3 ns;
        d <= c and w after 2 ns;
        cout <= b or d after 2 ns;
        product <= c xor w after 3 ns;

end flujo;

architecture procesos of multiplicador_1 is
        signal a, b, c, d: std_logic;
begin
        process (x, y)
        begin
                if x = '0' or y = '0' then a <= '0' after 2 ns;
                elsif x = 'X' or x = 'Z' or y = 'X' or y = 'Z' then a <= 'Z' after 2 ns;
                else a <= '1' after 2 ns;
                end if;
        end process;
        
        process (a, z)
                variable aa, zz, indice: integer:=0;                        
                constant suma: std_logic_vector (0 to 8) := "01X10XXXX";
                constant acarreo: std_logic_vector (0 to 8) := "00001X0XX";
        begin
                if a = '0' then aa := 0;
                elsif a = '1' then aa := 1;
                elsif a = 'Z' or a = 'X' then aa := 2;
                end if;

                if z = '0' then zz := 0;
                elsif z = '1' then zz := 1;
                elsif z = 'Z' or z = 'X' then zz := 2;
                end if;

                indice := zz + 3*aa;

                c <= suma (indice) after 2 ns;
                b <= acarreo (indice) after 3 ns;

        end process;

        process (b, d)
        begin
                if b = '1' or d = '1' then cout <= '1' after 2 ns;
                elsif b = 'X' or b = 'Z' or d = 'X' or d = 'Z' then cout <= 'X' after 2 ns;
                else cout <= '0' after 2 ns;
                end if;
        end process;

        process (c, w)
                variable cc, ww, indice: integer:=0;                        
                constant suma: std_logic_vector (0 to 8) := "01X10XXXX";
                constant acarreo: std_logic_vector (0 to 8) := "00001X0XX";
        begin
                if c = '0' then cc := 0;
                elsif c = '1' then cc := 1;
                elsif c = 'Z' or c = 'X' then cc := 2;
                end if;

                if w = '0' then ww := 0;
                elsif w = '1' then ww := 1;
                elsif w = 'Z' or w= 'X' then ww := 2;
                end if;

                indice := ww + 3*cc;

                product <= suma (indice) after 2 ns;
                d <= acarreo (indice) after 3 ns;

        end process;


end procesos;
